#include <stdio.h>
#include "iface.h"
#include "node1.h"
#include "grint.h"
#include "setup.h"


 static FILLSTYLE fillpars;
 static MODEPARS modepars;
 static VIEWPORT viewport;
 static PALETTE palette;
 static char comm, ttt [40];
 static int  xpos, ywl, yfr, freq, dfreq;


/* ----------------------------------------------------------------------*/


 void makescreen (void)
   {
   int driv, mode, i, x;

   KS_LockW (GRAPHRES);
   initgraph (VGA, VGAHI);
   setbkcolor (15);
   clearviewport ();

   setcolor (12);
   settextstyle (1, 0, 3);
   outtextxy (20, 16, "VIRTUOSO Load Balancing Demo");

   setcolor (1);
   settextstyle (3, 0, 8);
   outtextxy (20, 40, "ISI");

   settextstyle (0, 0, 1);
   outtextxy (100, 60, "Intelligent Systems International");
   outtextxy (100, 72, "Lindestraat 9  B3210 - Belgium");
   outtextxy (100, 84, "Tel : +32 16 62 15 85   Fax +32 16 62 15 84");

   setcolor (LNCOL);

   moveto (0, 212);
   lineto (640, 212);
   outtextxy (548, 216, "PROCESSORS");

   moveto (0, 142);
   lineto (640, 142);
   outtextxy (588, 146, "TASKS");


   setcolor (1);
   for (i = 0; i <5 ; i++)
     {
     x = 100 * i + 20;
     rectangle (x, 150, x + 72, 190);
     }
   for (i = 0; i < 4; i++)
     {
     x = 100 * i + 20;
     moveto (x +  72, 170);
     lineto (x + 100, 170);
     moveto (x +  96, 166);
     lineto (x + 100, 170);
     lineto (x +  96, 174);
     }
   outtextxy (124, 160, "Worker 1");
   outtextxy (224, 160, "Worker 2");
   outtextxy (324, 160, "Worker 3");

   setcolor (LNCOL);
   outtextxy (X0, Y0 +  8, "Type 1, 2 or 3 to move tasks");

   setcolor (WLCOL);
   outtextxy (X0, Y0 + 20, "Workload interval :   A 30ms B 100ms C 300ms D 1000ms");
   setcolor (FRCOL);
   outtextxy (X0, Y0 + 32, "Event frequency   :   + inc  - dec   * hold  0 reset");
   outtextxy ( 24, 160, "Generate");
   setcolor (RPCOL);
   outtextxy (424, 160, " Report ");

   setcolor (LNCOL);
   moveto (X0-1,   Y0+1);
   lineto (X0-1,   Y0-YS-1);
   lineto (X0+XS+1,Y0-YS-1);
   lineto (X0+XS+1,Y0+1);
   lineto (X0-1,   Y0+1);
   moveto (X0, Y0);

   KS_Unlock (GRAPHRES);
   }


/* ----------------------------------------------------------------------*/


 void command (void)
   {
   char k;
   while (1)
     {
     KS_DequeueW (CONIQ, &k, 1);
     switch (k)
       {
       case 'a' :
       case 'A' : KS_SetWlper (30); break;
       case 'b' :
       case 'B' : KS_SetWlper (100); break;
       case 'c' :
       case 'C' : KS_SetWlper (300); break;
       case 'd' :
       case 'D' : KS_SetWlper (1000); break;
       case '1' : comm = 1; break;
       case '2' : comm = 2; break;
       case '3' : comm = 3; break;
       case '+' : dfreq = +2; break;
       case '-' : dfreq = -2; break;
       case '*' : dfreq =  0; break;
       case '0' : freq = 0; dfreq = 2; break;
       }
     }
   }

/* ----------------------------------------------------------------------*/


 void report (void)
   {
   int n;
   K_TICKS t0, t1;
   char  e;

   KS_Elapse (&t0);
   t1 = n = 0;
   while (1)
     {
     KS_DequeueW (Q3TOR, &e, 1);
     n++;
     t1 += KS_Elapse (&t0);
     if (t1 > 1000)
       {
       fillpars.color = 0;
       fillpars.type = SOLID_FILL;
       KS_LockW (GRAPHRES);
       setfillstyle (&fillpars);
       bar (24, 200, 500, 208);
       setcolor (FRCOL);
       sprintf (ttt, "f = %4d", freq);
       outtextxy (24, 200, ttt);
       setcolor (RPCOL);
       sprintf (ttt, "f = %4d", n);
       outtextxy (424, 200, ttt);
       KS_Unlock (GRAPHRES);
       t1 -= 1000;
       n = 0;
       }
     }
   }


/* ----------------------------------------------------------------------*/


 void updatedisp (int w, int f)
   {
   int xclr, ywl1, yfr1;

   xclr = xpos + 100;
   if (xclr >= XS) xclr -= XS;
   KS_LockW (GRAPHRES);
   setcolor (15);
   moveto (X0 + xclr, Y0);
   linerel (0, -YS);
   ywl1 = w * YS;
   ywl1 /= 1000;
   yfr1 = f * YS;
   yfr1 /= FMAX;
   if (++xpos < XS)
     {
     setcolor (WLCOL);
     moveto (X0 + xpos, Y0 - ywl);
     ywl = ywl1;
     lineto (X0 + xpos, Y0 - ywl);
     setcolor (FRCOL);
     moveto (X0 + xpos, Y0 - yfr);
     yfr = yfr1;
     lineto (X0 + xpos, Y0 - yfr);
     }
   else xpos = 0;
   KS_Unlock (GRAPHRES);
   }


 void generate (void)
   {
   K_TIMER *T;
   int      frem, div1, div2;

   makescreen ();

   KS_Sleep (500);

   KS_Start (WORK1P1);   /* start worker tasks on root */
   KS_Start (WORK2P1);
   KS_Start (WORK3P1);

   KS_Start (WORK1P2);   /* start worker tasks on slave processors */
   KS_Start (WORK2P3);
   KS_Start (WORK3P4);

   KS_Suspend (WORK1P2); /* and suspend them, we start with 1 processor */
   KS_Suspend (WORK2P3);
   KS_Suspend (WORK3P4);


   KS_Sleep (500);
   comm = xpos = ywl = yfr = frem = div1 = div2 = 0;
   freq =  FMIN;
   dfreq = 2;

   T = KS_AllocTimer ();
   KS_StartTimer (T, T1, T1, CTICK);
   while (1)
     {
     KS_Wait (CTICK);
     frem += T1 * freq;             /* Bresenham algorithm to generate */
     while (frem > 0)               /* exact fractional frequencies    */
       {
       if (KS_Enqueue (QGTO1, &comm, 1) == RC_OK) comm = 0;
       frem -= 1000;
       }
     if (++div1 == 5)
       {
       div1 = 0;
       updatedisp (KS_Workload (), freq);
       }
     if (++div2 == 10)
       {
       div2 = 0;
       freq += dfreq;
       if (freq <= FMIN || freq >= FMAX) dfreq = 0;
       }
     }

   KS_LockW (GRAPHRES);
   closegraph ();
   graphresult ();
   KS_Unlock (GRAPHRES);
   }


/* ---------------------------------------------------------------------- */

  int sillywork (void)
    {
    int i, j;
    for (i = j = 0; i < LOAD; i++) j += i;
    return j;
    }

  void work1p1 (void)
    {
    char t;
    while (1)
      {
      KS_DequeueW (QGTO1, &t, 1);
      sillywork ();
      KS_EnqueueW (Q1TO2, &t, 1);
      if (t == 1)
	{
	KS_Resume (WORK1P2);
	KS_Suspend (KS_TaskId);
	}
      }
    }

  void work2p1 (void)
    {
    char t;
    while (1)
      {
      KS_DequeueW (Q1TO2, &t, 1);
      sillywork ();
      KS_EnqueueW (Q2TO3, &t, 1);
      if (t == 2)
	{
	KS_Resume (WORK2P3);
	KS_Suspend (KS_TaskId);
	}
      }
    }

  void work3p1 (void)
    {
    char t;
    while (1)
      {
      KS_DequeueW (Q2TO3, &t, 1);
      sillywork ();
      KS_EnqueueW (Q3TOR, &t, 1);
      if (t == 3)
	{
	KS_Resume (WORK3P4);
	KS_Suspend (KS_TaskId);
	}
      }
    }

/* ----------------------------------------------------------------------*/
