
#include <string.h>
#include "iface.h"
#include "node1.h"
#include "_stdio.h"


 static char String [128];
 static char Data [4096];


 static FILE *efopen (char *name, char *mode)
   {
   FILE *F;
   if ((F = fopen (name, mode)) == NULL)
     {
     fprintf (stderr, "Can't open '%s' in mode '%s'\n", name, mode);
     KS_Sleep (1000);
     }
   return F;
   }

 static void print_stat (struct stat *S)
   {
   printf ("st_dev   = %x\n", S->st_dev);
   printf ("st_ino   = %x\n", S->st_ino);
   printf ("st_mode  = %x\n", S->st_mode);
   printf ("st_nlink = %x\n", S->st_nlink);
   printf ("st_uid   = %x\n", S->st_uid);
   printf ("st_gid   = %x\n", S->st_gid);
   printf ("st_rdev  = %x\n", S->st_rdev);
   printf ("st_size  = %x\n", S->st_size);
   printf ("st_atime = %x\n", S->st_atime);
   printf ("st_mtime = %x\n", S->st_mtime);
   printf ("st_ctime = %x\n", S->st_ctime);
   }


 void test1 (void)
   {
   int      i, c;
   char    *ip;
   FILE    *F;
   K_TICKS  t, et;
   struct stat Stat;

   printf ("\nEXECUTING ON NODE %08x\n\n", KS_NodeId);
   KS_Sleep (500);

   printf ("\nPRINT TEXT FILE USING fgetc / fputc\n\n");
   KS_Sleep (1000);

   F = efopen ("test1.c", "rt");
   while ((c = fgetc (F)) != EOF) fputc (c, stderr);
   fclose (F);

   printf ("\nPRINT TEXT FILE USING fgets / fputs\n\n");
   KS_Sleep (1000);

   F = efopen ("test1.c", "rt");
   while (fgets (String, 128, F) != NULL) fputs (String, stderr);
   fclose (F);


   for (i = 0; i < 4096; i++) Data [i] = i;

   printf ("\nWRITE 2048 CHARS USING fwrite\n\n");

   F = efopen ("stdio.dat", "wb");
   printf ("fwrite : %5d\n", fwrite (Data, 1, 2048, F));
   fclose (F);

   printf ("\nAPPEND 2048 CHARS USING fwrite\n\n");

   F = efopen ("stdio.dat", "ab");
   printf ("fwrite : %5d\n", fwrite (Data + 2048, 1, 2048, F));
   fclose (F);

   for (i = 0; i < 4096; i++) Data [i] = 0xFF;

   printf ("\nREAD 4096 CHARS USING fread\n\n");

   F = efopen ("stdio.dat", "rb");
   for (ip = Data, i = 1; i <= 4096; ip += i, i <<= 1)
     {
     printf ("fread : %4d / %4d  ", fread (ip, 1, i, F), i, feof (F));
     printf ("feof : %d\n", feof (F));
     }
   for (i = 0; i < 4096; i++)
     {
     if (Data [i] != (i & 0xFF))
       {
       printf ("Error at %d, read %d\n", i, Data [i]);
       }
     }
   KS_Sleep (1000);

   printf ("\nGET INFO ON OPEN FILE USING fileno / fstat\n\n");

   printf ("fstat : %d\n", fstat (fileno (F), &Stat));
   print_stat (&Stat);
   KS_Sleep (1000);
   fclose (F);

   printf ("\nGET INFO ON FILE USING stat\n\n");

   printf ("stat : %d\n", stat ("stdio.dat", &Stat));
   print_stat (&Stat);
   KS_Sleep (1000);

   printf ("\nWRITE 64Kbytes BLOCK\n\n");

   F = efopen ("stdio.dat", "wb");
   KS_Elapse (&et);
   fwrite ((void *) 0x004000, 1, 0x010000, F);
   t = KS_Elapse (&et);
   fclose (F);
   printf ("Written 64 Kbytes in %d TICKS\n", t);

   remove ("stdio.dat");

   server_terminate ();
   }


