#include "iface.h"
#include "grint.h"
#include "allnodes.h"


 static FILLSTYLE fillpars;


 static int HSEG [] =
   {
    0,   0,
    4,  -4,
   44,  -4,
   48,   0,
   44,   4,
    4,   4 };

 static int VSEG [] =
   {
    0,   0,
   -4,  -4,
    0, -44,
    4, -48,
    8, -44,
    4,  -4 };

 static int SPOS [7][2] =
   {
     0,    0,
     4,  -50,
     8, -100,
    -1,   -1,
    49,   -1,
     3,  -51,
    53,  -51 };

 static int SMAP [] =
   {
   0x7D, 0x50, 0x4F, 0x57, 0x72, 0x37, 0x3F, 0x54, 0x7F, 0x77
   };

 static int XY [12];


 static void update (int *old, int *new, int xpos, int ypos, int color)
   {
   int i, j, m, upd, *p, *q;

   upd = *old ^ *new;
   KS_LockW (GRAPHRES);
   for (i = 0, m = 1; i < 7; i++, m <<= 1)
     {
     if (upd & m)
       {
       fillpars.type = SOLID_FILL;
       fillpars.color = (*new & m) ? color : DARKGRAY;
       setfillstyle (&fillpars);
       setcolor ((*new & m) ? color : DARKGRAY);

       if (i < 3) p = HSEG;
       else       p = VSEG;
       q = XY;
       for (j = 0; j < 6; j++)
	 {
	 *q++ = *p++ + xpos + SPOS [i][0];
	 *q++ = *p++ + ypos + SPOS [i][1];
	 }
       fillpoly (6, XY);
       }
     }
   KS_Unlock (GRAPHRES);
   *old = *new;
   }


 void digit (int xpos,
             int ypos,
	     K_SEMA in,
	     K_SEMA out,
	     int  modulus)
   {
   int cnt, old, new, color;

   switch (KS_NodeId)
     {
     case NODE1 : color = LIGHTMAGENTA; break;
     case NODE2 : color = YELLOW;       break;
     case NODE3 : color = LIGHTGREEN;   break;
     case NODE4 : color = LIGHTBLUE;    break;
     default    : color = WHITE;
     }

   old = 0x7f;
   new = 0x00;
   update (&old, &new, xpos, ypos, color);
   cnt = 0;

   while (1)
     {
     new = SMAP [cnt];
     update (&old, &new, xpos, ypos, color);
     KS_Wait (in);
     if (++cnt == modulus)
       {
       cnt = 0;
       KS_Signal (out);
       }
     }
   }


