#include "iface.h"
#include "grint.h"
#include "allnodes.h"


#define XBASE  500
#define YBASE  440
#define YSCALE 200


 static FILLSTYLE fillpars;


 void wlmon (void)
   {
   int color, x0, y0, y1;

   x0 = XBASE + 16 * ((KS_NodeId >> 16) - 1);
   y1 = 0;

   switch (KS_NodeId)
     {
     case NODE1 : color = MAGENTA; break;
     case NODE2 : color = YELLOW;  break;
     case NODE3 : color = GREEN;   break;
     case NODE4 : color = BLUE;    break;
     default    : color = WHITE;
     }

   KS_SetWlper (500);

   KS_LockW (GRAPHRES);
   fillpars.type = SOLID_FILL;
   fillpars.color = 7;
   setfillstyle (&fillpars);
   bar (x0, YBASE - YSCALE, x0 + 10, YBASE);
   KS_Unlock (GRAPHRES);

   while (1)
     {
     KS_Sleep (300);
     y0 = YSCALE * KS_Workload ();
     y0 /= 1000;
     if (y0 != y1)   /* workload has changed */
       {
       KS_LockW (GRAPHRES);
       if (y0 > y1)  /* workload has increased, make bar longer */
	 {
	 fillpars.type = SOLID_FILL;
	 fillpars.color = color;
	 setfillstyle (&fillpars);
	 bar (x0, YBASE - y0, x0 + 10, YBASE - y1);
	 }
       else          /* workload has decreased, make bar shorter */
	 {
	 fillpars.type = SOLID_FILL;
	 fillpars.color = 7;
	 setfillstyle (&fillpars);
	 bar (x0, YBASE - y1, x0 + 10, YBASE - y0);
	 }
       KS_Unlock (GRAPHRES);
       y1 = y0;      /* remember current workload */
       }
     }
   }



