/*
 ----------------------------------------------------------------------

   VIRTUOSO  Version 3.09

   Copyright (c) 1990-92
   Intelligent Systems International nv/sa

   Lindestraat 9, B-3210 Linden
   Belgium

   Tel +32 16.62.15.85
   Fax +32 16.62.15.84

 ----------------------------------------------------------------------
*/

#include "iface.h"
#include "node1.h"

#define CLCKFREQ  1000000      /* Internal timer clock frequency     */
#define TICKTIME     1000      /* K_TICK period in microseconds      */
#define TICKFREQ     1000      /* K_TICK frequency in Hertz          */
#define TICKUNIT     1000      /* K_TICK in CLCKFREQ units           */

#define DATALEN      1024      /* length of a data packet, bytes     */

#define NTIMERS        20      /* number of timers                   */
#define NCPACKS        60      /* number of command & mail packets   */
#define NDPACKS         0      /* number of data buffers             */

#define MONITSIZE    1024      /* number of monitor records          */
#define MONITMASK    MON_ALL   /* default monitoring level           */


/* ----------------------------------------------------------------------*/

 extern int kernel_init (void);
 extern int kernel_idle (void);
 extern int netload (void);


#ifdef HOSTRES
K_RES    hostres   = HOSTRES;
#endif

#ifdef CONIDRV
K_QUEUE  coniq     = CONIQ;
#endif

#ifdef CONODRV
K_QUEUE  conoq     = CONOQ;
#endif

#ifdef CONRES
K_RES    conres    = CONRES;
#endif

#ifdef STDIQ
K_QUEUE  stdiq     = STDIQ;
#endif

#ifdef STDOQ
K_QUEUE  stdoq     = STDOQ;
#endif

#ifdef STDIORES
K_RES    stdiores  = STDIORES;
#endif

#ifdef DEBUGIN
K_QUEUE  debugin   = DEBUGIN;
#endif

#ifdef GRAPHRES
K_RES    graphres  = GRAPHRES;
#endif

#ifdef GRAPHIQ
K_QUEUE  graphiq   = GRAPHIQ;
#endif

#ifdef GRAPHOQ
K_QUEUE  graphoq   = GRAPHOQ;
#endif

#ifdef TLDEBUG
 int K_monitor_size = MONITSIZE;
 int K_monitor_mask = MONITMASK;
#ifndef GRAPHDRV
 void SaveScreen (void) { KS_Nop (); }
 void RestScreen (void) { KS_Nop (); }
#endif
#endif

 int tickunit    = TICKUNIT;
 int ticktime    = TICKTIME;
 int K_DataSize  = DATALEN;
 int K_DataNall  = NDPACKS;
 int K_ArgsNall  = NCPACKS;
 int K_TimerNall = NTIMERS;


/* ----------------------------------------------------------------------*/

 int main ()
   {
   netload ();
   kernel_init ();
   if (K_ThisNode == 0x00010000) KS_StartG (EXE_GROUP);
   kernel_idle ();
   return 0;
   }

/* ----------------------------------------------------------------------*/



