/*
 ----------------------------------------------------------------------

   VIRTUOSO CLASSICO

   $Id: bgitags.h 1.3 94/05/16 11:00:40 FA REL3093 Locker: FA $

   Copyright (c) 1990-93
   Intelligent Systems International nv/sa

   Lindestraat 9, B-3210 Linden
   Belgium

   Tel +32 16.62.15.85
   Fax +32 16.62.15.84

 ----------------------------------------------------------------------
*/


/* BGITAGS.H - function tags for distributed graphics services */


#ifndef BGITAGS_H
#define BGITAGS_H


#define BGI_TEXT 0x8000
#define BGI_POLY 0x4000
#define BGI_WTOH(x) ((x & 0x0F00) >> 8)
#define BGI_WFRH(x) ((x & 0x00F0) >> 4)


#define BGI_GETMDEP   0x0060
#define BGI_GETUSRP   0x00A1
#define BGI_GETVIEW   0x0052
#define BGI_GETAPAL   0x0043
#define BGI_GETFILL   0x0044
#define BGI_GETCURR   0x0025
#define BGI_GETARCC   0x0066
#define BGI_GRESULT   0x0017
#define BGI_SETVIEW   0x0508
#define BGI_SETAPAL   0x0409
#define BGI_SETFILL   0x040A
#define BGI_DETECTGR  0x002B
#define BGI_INITGR    0x020C
#define BGI_GETIMGE   0x041D
#define BGI_SAVESCR   0x001E
#define BGI_RESTSCR   0x000F

#define BGI_CLRDEVC   0x1000
#define BGI_CLRVIEW   0x1001
#define BGI_CLSGRAPH  0x1002
#define BGI_GRDEFAULT 0x1003
#define BGI_RESTMODE  0x1004

#define BGI_ACTPAGE   0x1100
#define BGI_VISPAGE   0x1101
#define BGI_BACKCOL   0x1102
#define BGI_FORECOL   0x1103
#define BGI_GRMODE    0x1104
#define BGI_WRIMODE   0x1105
#define BGI_FREAREA   0x1106

#define BGI_LINEREL   0x1200
#define BGI_MOVEREL   0x1201
#define BGI_LINETO    0x1202
#define BGI_MOVETO    0x1203
#define BGI_SETTJFY   0x1204
#define BGI_SETPAL    0x1205

#define BGI_PUTPIXEL  0x1300
#define BGI_FLOODFLL  0x1301
#define BGI_PLCIRCLE  0x1302
#define BGI_SETTXTST  0x1303
#define BGI_SETLNEST  0x1304

#define BGI_PLOTBAR   0x1400
#define BGI_PLOTRECT  0x1401
#define BGI_PLOTLINE  0x1402
#define BGI_USRCSIZE  0x1403
#define BGI_FILLELL   0x1404
#define BGI_PUTIMGE   0x1405
#define BGI_RGBPAL    0x1406

#define BGI_PLOTARC   0x1500
#define BGI_PIESLICE  0x1501

#define BGI_ELLIPS    0x1601
#define BGI_BAR3DIM   0x1602
#define BGI_SECTOR    0x1603

#define BGI_DRAWPOLY  0x4000
#define BGI_FILLPOLY  0x4001

#define BGI_INSTFONT  0x8010
#define BGI_TEXTDIMS  0x8021
#define BGI_OUTTEXT   0x8002
#define BGI_OUTTXTXY  0x8203

#endif
